use std::sync::atomic::{AtomicBool, Ordering};

static CALLED_BAR: AtomicBool = AtomicBool::new(false);

use testdep::testdep;

struct Foo(usize);

#[testdep]
fn foo(bar: &i32) -> Foo {
    assert_eq!(*bar, 10);
    Foo(42)
}

#[testdep]
fn another_foo(bar: &i32) {
    assert_eq!(*bar, 10);
}

#[testdep]
fn bar() -> i32 {
    // Ensure that bar has only been called once.
    assert_eq!(CALLED_BAR.load(Ordering::SeqCst), false);
    CALLED_BAR.store(true, Ordering::SeqCst);

    10
}

#[testdep]
fn use_foo(foo: Foo) {
    assert_eq!(foo.0, 42);
}
